#include <stdio.h>
#include <stdlib.h>

#define MAX_SIZE 100
#define FALSE 0
#define TRUE 1
#define NONE -1
#define true 1
// prints a permutation of n integers stored in array p
void printPermutation(int *p, int n)
{
    for (int i = 0; i < n; i++)
        printf("%d ", p[i] + 1);
    printf("\n");
}
/*
Pseudocode:
Permute(unused, p, L, N)
   if(L > N)
      process the permutation p
   else
      for each i in unused do
         p[L]=i;
         Permute(unused-{i}, p, L+1, N)    <---recursion
      end for
   end if
end Permute;
Call Permute({1..n}, p, 1, N)
*/
// permutes n integers in array p
void permute(char unused[], int p[], int limit, int n)
{
    if (limit >= n) // proicess permutation
        printPermutation(p, n);
    else
        for (int i = 0; i < n; i++)
        {
            if (unused[i])
            {
                p[limit] = i;
                unused[i] = FALSE; // i is now used
                permute(unused, p, limit + 1, n); // recursive call
                unused[i] = TRUE; // free i
            }
        }
}
int main()
{
    char *unused;
    int *p; //permutation array
    int n = 0; // number of elements in the set to permute

    while (n == 0)
    {
        printf("n=");
        scanf("%d", &n);
        if (n < 2) printf("Bad value: %d\n", n);
    }

    unused = (char *)malloc(n * sizeof(char));
    p = (int *)malloc(n * sizeof(int));
    if (!p || !unused) // check alloc success
    {
        printf("%s: No memory\n", __FUNCTION__);
        exit(1);
    }
    for (int i = 0; i < n; i++) // init arrays
    {
        unused[i] = TRUE;
        p[i] = NONE;
    }
    permute(unused, p, 0, n);
    return 0;
}
